#!/usr/bin/wish -f

# This program is written by 
#               
#                             Murtaza Amiji
#		Department Of ELectrical & Computer Engineering,
#		     Worcester Polytechnic Institute,
#		            Worcester, MA.
#                       E-Mail: murti@ece.wpi.edu
#                Personal Homepage: http://www.wpi.edu/~murti
#                    ECE Homepage: http://ece.wpi.edu
#
# Copyright (c) 1995-96 Worcester Polytechnic Institute. 
# All rights reserved.
# 
# Permission is hereby granted, without written agreement and without
# license or royalty fees, to use, copy, modify, and distribute this
# software and its documentation for non commericial purpose, provided that 
# the above copyright notice and the following two paragraphs appear in
# all copies of this software.
# 
# IN NO EVENT SHALL WORCESTER POLYTECHNIC INSTITUTE BE LIABLE TO ANY PARTY FOR
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
# OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF WORCESTER 
# POLYTECHNIC INSTITUTE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# WORCESTER POLYTECHNIC INSTITUTE SPECIFICALLY DISCLAIMS ANY WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
# ON AN "AS IS" BASIS, AND WORCESTER POLYTECHNIC INSTITUTE HAS NO OBLIGATION 
# TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.


wm title . "E-Phone" 

frame .mbar -relief raised -bd 2
frame .input
pack .mbar -side top -fill x
pack .input

text .input.text -relief raised -bd 2 -height 20 -width 70 -background white \
-yscrollcommand ".input.scroll set" \
-font -adobe-times-medium-r-normal--14-140-75-75-p-77-iso8859-1 
scrollbar .input.scroll -command ".input.text yview" 
 
menubutton .mbar.configure -text Configure -underline 0 \
-menu .mbar.configure.menu
menubutton .mbar.help -text Help -underline 0 -menu .mbar.help.menu
button .connect -text "Connect..." -command "connect"
button .hangup -text "Hangup" -command "hangup"
button .exit -text "Exit" -command "stop"

pack .mbar.configure -side left
pack .mbar.help -side right -padx 2m
pack .input.text .input.scroll -side left -fill y -expand 1
pack .connect .hangup .exit -side left -padx 1m -pady 1m

menu .mbar.configure.menu
.mbar.configure.menu add command -label " XMix Sound Mixer... " \
-command "exec ./xmix.static &"

menu .mbar.help.menu
.mbar.help.menu add command -label " E-Phone FAQ... " -command "faq .faq"
.mbar.help.menu add command -label " Sound HOWTO... " -command "sound-howto .howto"
.mbar.help.menu add command -label " About E-Phone... " -command "AboutMessage .about"

bind . <Any-FocusIn> {
    if {("%d" == "NotifyVirtual") && ("%m" == "NotifyNormal")} {
	focus .mbar
    }
}
tk_menuBar .mbar .mbar.configure .mbar.help


proc dpos {w} {
    wm geometry $w 300x120
}
# pfd is a global and we use "" to mean not opened yet

set pfd ""

if {[string length $pfd] <= 0} {
    set pfd [open "| ./ephone_server"  "a+"]
    if {$pfd <= 0} {
	.input.text insert end "Cannot open E-Phone server. The server or the client is already running.\n"
	exit 0
    }	

    .input.text delete 1.0 end 
}  

proc output_looper {} {
    global pfd
    #if pfd isn't open yet there's nothing to do
    
    if {[string length $pfd] <= 0} {
	after 250 output_looper
 	return
    }
    #.input.text delete 1.0 end

    #we can skip the timeout here because we'll return to try again
    #several times a second
    
    set timeout 0
    lassign [select [list $pfd] {} {} $timeout] readable writeable errored
    if {[llength $readable] > 0} {
	set z [gets $pfd]
	if {[llength $z] > 0} {
	    .input.text insert end "$z\n"
	}
    }

    #don't use a flush here: we're only reading

    after 250 output_looper
}


#call output_looper once at the bottom to get it started.
output_looper
update

































